////////////////////////////////////////////////////////////////////////////////////////////////
//
//  HgToonShader v0.0.1  ₷d̃gD[nVF[_ł
//  (HgToonShader_Main.fxh : ̃VF[_̃CvO)
//  쐬: jP
//
////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef MIKUMIKUSHADING_TEST

#include "MMShader/Common/MMD_Parameters.fxh"
#include "MMShader/HgToonShader/HgToonShader_SubFunc.fxh"

#if M0032_SELFSHADOWMODE == 3
#include "MMShader/Common/HgShadow_ObjHeader.fxh"
#endif

#if M0032_SELFSHADOWMODE == 4
#include "MMShader/Common/ExcellentShadow_ObjHeader.fxh"
#endif

#if M0032_SELFSHADOWMODE == 5
#include "MMShader/Common/LocalShadow_Header1.fxh"
#endif

#if M0032_SELFSHADOWMODE == 6
#include "MMShader/Common/LocalShadow_Header2.fxh"
#endif

#else

#include "MMD_Parameters.fxh"
#include "HgToonShader_SubFunc.fxh"

#if M0032_SELFSHADOWMODE == 3
#include "HgShadow_ObjHeader.fxh"
#endif

#if M0032_SELFSHADOWMODE == 4
#include "ExcellentShadow_ObjHeader.fxh"
#endif

#if M0032_SELFSHADOWMODE == 5
#include "LocalShadow_Header1.fxh"
#endif

#if M0032_SELFSHADOWMODE == 6
#include "LocalShadow_Header2.fxh"
#endif

#endif

////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef M0032_USE_NORMALMAP1
#ifdef M0032_EXIST_NORMALMAP1
   #define M0032_VALID_NORMALMAP1
#endif
#endif

#ifndef M0032_VALID_NORMALMAP1
#ifndef M0032_USE_INSTANTNORMALMAP
    #define M0032_NOTING_NORMALMAP
#endif
#endif

#ifndef M0032_USE_COLORREMAP
#ifndef M0032_USE_INSTANTNORMALMAP
    #define M0032_NOTING_RENDERTARGET
#endif
#endif


// @}bv1
#ifdef M0032_VALID_NORMALMAP1
texture2D M0032_NormalMap1 <
    string ResourceName = M0032_NORMALMAP_FILE1;
    int MipLevels = 0;
>;
sampler M0032_NormalMapSamp1 = sampler_state {
    texture = <M0032_NormalMap1>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};
#endif

// CCggUToon}bv
texture2D M0032_ToonMapDiffuse0 <
    string ResourceName = M0032_TOONMAP_DIFFUSE_FILE0;
    int MipLevels = 0;
>;
sampler M0032_ToonMapDiffuseSamp0 = sampler_state {
    texture = <M0032_ToonMapDiffuse0>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};

// ˌToon}bv
texture2D M0032_ToonMapSpecular <
    string ResourceName = M0032_TOONMAP_SPECULAR_FILE;
    int MipLevels = 0;
>;
sampler M0032_ToonMapSpecularSamp = sampler_state {
    texture = <M0032_ToonMapSpecular>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};

// ⏕Cg1gUToon}bv
#ifdef M0032_USE_LIGHT1
texture2D M0032_ToonMapDiffuse1 <
    string ResourceName = M0032_TOONMAP_DIFFUSE_FILE1;
    int MipLevels = 0;
>;
sampler M0032_ToonMapDiffuseSamp1 = sampler_state {
    texture = <M0032_ToonMapDiffuse1>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};
#endif

// ZtVhEEToon}bv
#if M0032_SELFSHADOWMODE > 0
texture2D M0032_ToonMapSelfShadow <
    string ResourceName = M0032_TOONMAP_SELFSHADOW_FILE;
    int MipLevels = 0;
>;
sampler M0032_ToonMapSelfShadowSamp = sampler_state {
    texture = <M0032_ToonMapSelfShadow>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};
#endif


////////////////////////////////////////////////////////////////////////////////////////////////
// eNX`̃J[}bv
#ifdef M0032_USE_COLORREMAP

// J[}bvpToon}bv
texture2D M0032_ToonMapColorRemap0 <
    string ResourceName = M0032_TOONMAP_COLORREMAP_FILE0;
    int MipLevels = 0;
>;
sampler M0032_ToonMapColorRemapSamp0 = sampler_state {
    texture = <M0032_ToonMapColorRemap0>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};

#ifdef M0032_REPLACE_TEXTURECOLOR
texture2D M0032_ToonMapColorRemap1 <
    string ResourceName = M0032_TOONMAP_COLORREMAP_FILE1;
    int MipLevels = 0;
>;
sampler M0032_ToonMapColorRemapSamp1 = sampler_state {
    texture = <M0032_ToonMapColorRemap1>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};
#endif

texture M0032_ColorRemapTexture : RENDERCOLORTARGET <
    int Width = M0032_COLORREMAP_TEXSIZE;
    int Height = M0032_COLORREMAP_TEXSIZE;
    int MipLevels = 0;
    string Format = "D3DFMT_A8R8G8B8" ;
>;
sampler M0032_ColorRemapSampler = sampler_state {
    texture = <M0032_ColorRemapTexture>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    MAXANISOTROPY = 16;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

texture2D M0032_ColorRemapDepthBuffer : RENDERDEPTHSTENCILTARGET <
    int Width = M0032_COLORREMAP_TEXSIZE;
    int Height = M0032_COLORREMAP_TEXSIZE;
    string Format = "D3DFMT_D24S8";
>;

// _O^[Qbg̃NAl
float4 M0032_ColorRemapClearColor = {0,0,0,0};
float M0032_ColorRemapClearDepth  = 1.0;

struct M0032_VS_OUTPUT_COLORREMAP {
    float4 Pos  : POSITION;
    float2 Tex  : TEXCOORD0;
};
// Ȗ@}bv`̒_VF[_
M0032_VS_OUTPUT_COLORREMAP M0032_VS_ColorRemapCreater( float4 Pos : POSITION, float2 Tex : TEXCOORD0 )
{
    M0032_VS_OUTPUT_COLORREMAP Out;
    Out.Pos = Pos;
    Out.Tex = Tex + (float2(0.5f, 0.5f) / M0032_COLORREMAP_TEXSIZE);
    return Out;
}

// Ȗ@}bv`̃sNZVF[_
float4  M0032_PS_ColorRemapCreater(float2 Tex: TEXCOORD0) : COLOR0
{
    float4 TexColor = tex2D( ObjTexSampler, Tex );

    float3 TexColorR;
    float clen = 1000.0f;
    for(int i=0; i<(M0032_COLORREMAP_COUNT); i++){
       float2 texm = float2(((float)i + 0.5f)/((float)(M0032_COLORREMAP_COUNT)), 0.5f);
       float3 color0 = tex2D( M0032_ToonMapColorRemapSamp0, texm ).rgb;
       float clen1 = length(color0 - TexColor.rgb);
       #ifndef M0032_REPLACE_TEXTURECOLOR
       if(clen1 < clen){
          TexColorR = color0;
          clen = clen1;
       }
       #else
       float3 color1 = tex2D( M0032_ToonMapColorRemapSamp1, texm ).rgb;
       if(clen1 < clen){
          TexColorR = color1;
          clen = clen1;
       }
       #endif
    }
    TexColor.rgb = TexColorR;

    return TexColor;
}

#endif


////////////////////////////////////////////////////////////////////////////////////////////////
// Ȗ@}bv쐬
#ifdef M0032_USE_INSTANTNORMALMAP

texture M0032_InstantNormalMapTexture : RENDERCOLORTARGET <
    int Width = M0032_INSTANTNORMALMAP_TEXSIZE;
    int Height = M0032_INSTANTNORMALMAP_TEXSIZE;
    int MipLevels = 0;
    string Format = "D3DFMT_A8R8G8B8" ;
>;
sampler M0032_InstantNormalMapSampler = sampler_state {
    texture = <M0032_InstantNormalMapTexture>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    MAXANISOTROPY = 16;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

texture2D M0032_InstantNormalMapDepthBuffer : RENDERDEPTHSTENCILTARGET <
    int Width = M0032_INSTANTNORMALMAP_TEXSIZE;
    int Height = M0032_INSTANTNORMALMAP_TEXSIZE;
    string Format = "D3DFMT_D24S8";
>;

// _O^[Qbg̃NAl
float4 M0032_InstantNormalMapClearColor = {0,0,0,0};
float M0032_InstantNormalMapClearDepth  = 1.0;

struct M0032_VS_OUTPUT_INSTANTNORMALMAP {
    float4 Pos  : POSITION;
    float2 Tex  : TEXCOORD0;
};
// Ȗ@}bv`̒_VF[_
M0032_VS_OUTPUT_INSTANTNORMALMAP M0032_VS_InstantNormalMapCreater( float4 Pos : POSITION, float2 Tex : TEXCOORD0 )
{
    M0032_VS_OUTPUT_INSTANTNORMALMAP Out;
    Out.Pos = Pos;
    Out.Tex = Tex + (float2(0.5f, 0.5f) / M0032_INSTANTNORMALMAP_TEXSIZE);
    return Out;
}

// Ȗ@}bv`̃sNZVF[_
float4  M0032_PS_InstantNormalMapCreater(float2 Tex: TEXCOORD0) : COLOR0
{
    float4 Color = float4(0.5f, 0.5f, 1.0f, 1.0f);
    if(use_texture){
        float2 TexStep = float2(1.0f, 1.0f) * M0032_INSTANTNORMALMAP_SAMPSTEP / M0032_INSTANTNORMALMAP_TEXSIZE;
        float4 TexColor0 = tex2D(ObjTexSampler, Tex);
        float4 TexColorL = tex2D(ObjTexSampler, Tex+float2( TexStep.x, 0.0f));
        float4 TexColorR = tex2D(ObjTexSampler, Tex+float2(-TexStep.x, 0.0f));
        float4 TexColorU = tex2D(ObjTexSampler, Tex+float2(0.0f,-TexStep.y));
        float4 TexColorD = tex2D(ObjTexSampler, Tex+float2(0.0f, TexStep.y));
        float v0 = 0.298912f * TexColor0.r + 0.586611f * TexColor0.g + 0.114478f * TexColor0.b;
        float vL = 0.298912f * TexColorL.r + 0.586611f * TexColorL.g + 0.114478f * TexColorL.b;
        float vR = 0.298912f * TexColorR.r + 0.586611f * TexColorR.g + 0.114478f * TexColorR.b;
        float vU = 0.298912f * TexColorU.r + 0.586611f * TexColorU.g + 0.114478f * TexColorU.b;
        float vD = 0.298912f * TexColorD.r + 0.586611f * TexColorD.g + 0.114478f * TexColorD.b;
        Color.rgb = normalize( float3(vL-vR, vD-vU, 1.0f) );
        Color.rgb = (Color.rgb + 1.0f) * 0.5f;
        Color.a = v0;
    }
    return Color;
}

#endif


#ifndef M0032_OUTPUT_MIRROR_OBJECT
///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`

struct M0032_VS_INPUT {
    float4 Pos    : POSITION;     // f_W
    float3 Normal : NORMAL;       // @
    float2 Tex    : TEXCOORD0;    // UVW
};

struct M0032_VS_OUTPUT {
    float4 Pos       : POSITION;     // ˉeϊW
    float4 ZCalcTex  : TEXCOORD0;    // Zl
    float2 Tex       : TEXCOORD1;    // eNX`
    float3 Normal    : TEXCOORD2;    // @
    float3 Eye       : TEXCOORD3;    // JƂ̑Έʒu
    float4 PPos      : TEXCOORD4;    // HgShadow,ExcellentShadowpˉeW
    float4 ZCalcTex2 : TEXCOORD5;    // LocalShadowpZl
};


// _VF[_
M0032_VS_OUTPUT M0032_VS_Object(M0032_VS_INPUT IN)
{
    M0032_VS_OUTPUT Out = (M0032_VS_OUTPUT)0;

    // J_̃[hr[ˉeϊ
    Out.Pos = mul( IN.Pos, WorldViewProjMatrix );
    Out.PPos = Out.Pos;

    // _@
    Out.Normal = normalize( mul( IN.Normal, (float3x3)WorldMatrix ) );

    // @琳ʕɕ␳
    #ifdef M0032_UPDATE_FACENORMAL
    float3 WPos = mul( IN.Pos, WorldMatrix ).xyz;
    Out.Normal = HgToonShader_GetFlontFaceNormal(WPos, Out.Normal, M0032_FACENORMAL_VDIR, M0032_FACENORMAL_RATE_H, M0032_FACENORMAL_RATE_V);
    #endif

    // JƂ̑Έʒu
    Out.Eye = CameraPosition - mul( IN.Pos, WorldMatrix ).xyz;

    // Cg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex = mul( IN.Pos, LightWorldViewProjMatrix );

    #if (M0032_SELFSHADOWMODE == 5 || M0032_SELFSHADOWMODE == 6)
    // LocalCg_ɂ郏[hr[ˉeϊ
    Out.ZCalcTex2 = mul( IN.Pos, LocalShadow_LightWorldViewProjMatrix );
    #endif

    // eNX`W
    Out.Tex = IN.Tex;

    // ExcellentShadow̒iɂ邿h~
    #if (M0032_SELFSHADOWMODE == 4)
    Out.Pos.z -= max(0, (int)((ExShadow_CameraDistance1 - 6000) * 0.04));
    #endif

    return Out;
}


////////////////////////////////////////////////////////////////////////////////////////////////

// sNZVF[_
float4 M0032_PS_Object(M0032_VS_OUTPUT IN, uniform bool UseSelfShadow) : COLOR
{
    // LocalShadowgp̃CgC
    #if (M0032_SELFSHADOWMODE == 5 || M0032_SELFSHADOWMODE == 6)
        LightDirection = LocalShadow_GetLightDirection(LightDirection);
    #endif

    // f@
    float3 Normal0 = normalize(IN.Normal);

    // ˌEXtBA}bv̖@
    float3 NormalS = Normal0;

    // ʕ
    float3 ViewDir = normalize(IN.Eye);

    // ̃sNZ̖@ݒ
    #ifdef M0032_NOTING_NORMALMAP
    // @}bv
        float3 Normal = Normal0;
    #else
    // @}bvL
        // ڋԂViewԂւ̕ϊs
        float3x3 TangentMatrix = HgToonShader_GetTangentMatrix(Normal0, IN.Eye, IN.Tex);
        // ViewԂڋԂւ̕ϊs
        float3x3 invTangentMatrix = transpose(TangentMatrix);

        // @}bv1
        #ifdef M0032_VALID_NORMALMAP1
            float2 NormalMapUV1 = IN.Tex / max((M0032_NORMALMAP_SCALE1), 0.01f) + (M0032_NORMALMAP_SHIFT1);
            #ifdef M0032_NORMALMAP_PARALLAX1
                float Height1 = tex2D(M0032_NormalMapSamp1, NormalMapUV1).a;
                NormalMapUV1 -= mul(ViewDir, invTangentMatrix).xy * Height1 * 0.01f * (M0032_NORMALMAP_PARALLAX_PARAM1) * (M0032_NORMALMAP_HEIGHT1);
            #endif
            float3 Normal1 = 2.0f * tex2D(M0032_NormalMapSamp1, NormalMapUV1).xyz - 1.0f;
            Normal1.xy *= (M0032_NORMALMAP_HEIGHT1);
            Normal1 = normalize(Normal1);
            Normal1 /= max(Normal1.z, 0.001f);
        #else
            float3 Normal1 = float3(0,0,1);
        #endif

        // Ȗ@}bv
        #ifdef M0032_USE_INSTANTNORMALMAP
            #ifdef M0032_INSTANTNORMALMAP_PARALLAX
                float Height2 = tex2D(M0032_InstantNormalMapSampler, IN.Tex).a;
                float2 TexCoord2 = IN.Tex - mul(ViewDir, invTangentMatrix).xy * Height2 * 0.01f * (M0032_INSTANTNORMALMAP_PARALLAX_PARAM) * (M0032_INSTANTNORMALMAP_HEIGHT);
                float3 Normal2 = 2.0f * tex2D(M0032_InstantNormalMapSampler, TexCoord2).xyz - 1.0f;
            #else
                float3 Normal2 = 2.0f * tex2D(M0032_InstantNormalMapSampler, IN.Tex).xyz - 1.0f;
            #endif
            Normal2.xy *= (M0032_INSTANTNORMALMAP_HEIGHT);
            Normal2 = normalize(Normal2);
            Normal2 /= max(Normal2.z, 0.001f);
        #else
            float3 Normal2 = float3(0,0,1);
        #endif

        // gp@}bv̍
        float3 Normal = normalize(float3(Normal1.xy + Normal2.xy, 1.0));

        // ڋԂViewԂւ̕ϊ
        Normal = mul(Normal, TangentMatrix);

        // ˌEXtBA}bv̖@
        NormalS = normalize(lerp(Normal0, Normal, M0032_SSNORMAL_RATE));
    #endif

    // CCgݒ
    float3 Lt0Dir = normalize(-LightDirection); // 
    float3 Lt0Color = LightSpecular * (M0032_LIGHT0_COLOR);  // CgF
    float Lt0Foctor = M0032_LIGHT0_FOCTOR;          // ex

    // ⏕Cgݒ
    #ifdef M0032_USE_LIGHT1
        float3 Lt1Dir = ViewDir;                       // 
        float  Lt1Foctor = M0032_LIGHT1_FOCTOR;              // ex
        float  Lt1SpecFoctor = M0032_LIGHT1_SPECULAR_FOCTOR; // XyLex
        #ifdef M0032_USE_LIGHT1_COLOR
            float3 Lt1Color = M0032_LIGHT1_COLOR * 0.6f; // CgF
        #else
            float3 Lt1Color = Lt0Color;  // CgF
        #endif
    #endif

    // eF̉ex
    float ambientFoctor = M0032_AMBIENT_FOCTOR;
    float diffuseFoctor = M0032_DIFFUSE_FOCTOR;
    float specularFoctor = M0032_SPECULAR_FOCTOR;

    // \ʂ̂x
    float Roughness = (M0032_ROUGHNESS);

    // ˎ̃tl˗
    float3 Fresnel0 = M0032_FRESNEL0;

    // eF̔Z
    float ShadowDensity = M0032_SHADOW_DENSITY;

    // ArGg̃x[XJ[
    float3 AmbientColor = MaterialEmmisive * LightAmbient;
    float3 AmbientColorAcs = MaterialAmbient * LightAmbient + MaterialEmmisive;
    float3 ambient = use_toon ? AmbientColor*MaterialToon : AmbientColorAcs;
    ambient *= (M0032_LIGHT0_COLOR);

    // fBt[Y,XyL̃x[XJ[(Cg͌ōl)
    float4 diffuse = MaterialDiffuse;
    #ifndef M0032_USE_CUSTUM_SPECULARCOLOR
        float3 specular = MaterialSpecular;
        float specPower = SpecularPower;
    #else
        float3 specular = MaterialDiffuse.rgb;
        float specPower = (M0032_CUSTUM_SPECULAR_POWER);
    #endif

    // eNX`Kp
    if ( use_texture ) {
        #ifndef M0032_USE_COLORREMAP
        float4 TexColor = tex2D( ObjTexSampler, IN.Tex );
        #else
        float4 TexColor = tex2D( M0032_ColorRemapSampler, IN.Tex );
        #endif

        #ifndef M0032_FLG_EXCEPTION
        // eNX`ގ[t
        TexColor.rgb = lerp(1, TexColor * TextureMulValue + TextureAddValue, TextureMulValue.a + TextureAddValue.a).rgb;
        #endif

        diffuse *= TexColor;
        ambient *= TexColor.rgb;
    }

    // ArGgF
    float4 Color = float4(ambient * ambientFoctor, diffuse.a);

    // e̐F
    float4 ShadowColor = Color;

    // fBt[YFǉ
    float4 duffColor0 = diffuse * float4(Lt0Color, 1.0f);
    Color.rgb = HgToonShader_GetDiffuseColor(Color.rgb, duffColor0, Normal, Lt0Dir,
                    M0032_ToonMapDiffuseSamp0, M0032_TOONMAP_DIFFUSE_MINRANGE0, 1.0f, ShadowDensity, diffuseFoctor * Lt0Foctor, M0032_TOONMAP_DIFFUSE_CALCTYPE0);
    ShadowColor.rgb = HgToonShader_GetDiffuseColor(ShadowColor.rgb, duffColor0, Normal, Lt0Dir,
                         M0032_ToonMapDiffuseSamp0, M0032_TOONMAP_DIFFUSE_MINRANGE0, M0032_SELFSHADOW_BIAS, ShadowDensity, diffuseFoctor * Lt0Foctor, M0032_TOONMAP_DIFFUSE_CALCTYPE0);

    float3 duffColor = float3(0.0f, 0.0f, 0.0f);
    #ifdef M0032_USE_LIGHT1
        duffColor0 = diffuse * float4(Lt1Color, 1.0f);
        duffColor += HgToonShader_GetDiffuseColor(float3(0.0f, 0.0f, 0.0f), duffColor0, Normal, Lt1Dir,
                        M0032_ToonMapDiffuseSamp1, M0032_TOONMAP_DIFFUSE_MINRANGE1, 1.0f, ShadowDensity, diffuseFoctor * Lt1Foctor, M0032_TOONMAP_DIFFUSE_CALCTYPE1);
    #endif

    Color.rgb += duffColor;
    ShadowColor.rgb += duffColor;
    Color = saturate( Color );
    ShadowColor = saturate( ShadowColor );

    // XyLFǉ
    float3 specColor = specular * specPower * specularFoctor;
    float3 specularRate = HgToonShader_GetSpecularRate(Fresnel0, NormalS, ViewDir, Lt0Dir, Roughness);
    float3 specColor0 = specColor * specularRate * Lt0Color * Lt0Foctor;

    #ifdef M0032_USE_LIGHT1
        specularRate = HgToonShader_GetSpecularRate(Fresnel0, NormalS, ViewDir, Lt1Dir, Roughness);
        specColor0 += specColor * specularRate * Lt1Color * Lt1Foctor * Lt1SpecFoctor;
    #endif

    float specPower0 = (specColor0.r + specColor0.g + specColor0.b) / 3.0f;
    specColor0 *= tex2D( M0032_ToonMapSpecularSamp, float2(saturate(specPower0.r), 0.5f) ).rgb * M0032_TOONMAP_SPECULAR_SCALE;

    Color.rgb += specColor0;
    ShadowColor.rgb += specColor0 * 0.2f;

    // Cgǉ
    #ifdef M0032_USE_RIMLIGHT
        float Rim = 1.0f - max( 0.0f, dot(Normal0, ViewDir) );
        Rim = pow(Rim, 1.0f/max(M0032_RIMLIGHT_SCALE, 0.01f)) * (M0032_RIMLIGHT_POWER);
        Color.rgb += (M0032_RIMLIGHT_COLOR) * Rim;
        ShadowColor.rgb += (M0032_RIMLIGHT_COLOR) * Rim;
    #endif

    // XtBA}bvKp
    #ifdef M0032_DRAW_SPHEREMAP
    if ( use_spheremap ) {
        #ifndef M0032_SPHEREMAP_ZROT_COMPLIANCE
            float2 NormalWV = mul( NormalS, (float3x3)ViewMatrix ).xy;
        #else
            float3x3 ViewMatrixZRot = HgToonShader_ViewMatrixZRot(CameraPosition, CameraDirection);
            float2 NormalWV = mul( NormalS, ViewMatrixZRot ).xy;
        #endif
        float2 SpTex = float2( NormalWV.x * 0.5f + 0.5f, NormalWV.y * -0.5f + 0.5f );
        float4 TexColor = tex2D(ObjSphareSampler, SpTex);
        #ifndef M0032_FLG_EXCEPTION
        // XtBAeNX`ގ[t
        TexColor.rgb = lerp(spadd?0:1, TexColor * SphereMulValue + SphereAddValue, SphereMulValue.a + SphereAddValue.a).rgb;
        #endif
        if(spadd) {
            Color.rgb += TexColor.rgb;
            ShadowColor.rgb += TexColor.rgb;
        } else {
            Color.rgb *= TexColor.rgb;
            ShadowColor.rgb *= TexColor.rgb;
        }
        Color.a *= TexColor.a;
        ShadowColor.a *= TexColor.a;
    }
    #endif

    // 臒lȉ͕`悵Ȃ
    clip(Color.a - max(M0032_ALPHA_CLIP, 0.004f));

    // ZtVhE`
    #if (M0032_SELFSHADOWMODE > 0)
    if(UseSelfShadow){
        float comp = 1.0;
        float LightNormal = dot(Normal, Lt0Dir);

        // LocalShadowɂՕ
        #if (M0032_SELFSHADOWMODE == 5 || M0032_SELFSHADOWMODE == 6)
        if( LocalShadow_Valid ){

            // eNX`Wɕϊ
            IN.ZCalcTex2 /= IN.ZCalcTex2.w;
            float2 TransTexCoord;
            TransTexCoord.x = (1.0f + IN.ZCalcTex2.x)*0.5f;
            TransTexCoord.y = (1.0f - IN.ZCalcTex2.y)*0.5f;

            // LocalVhE}bvɂՕ
            if( !any( saturate(TransTexCoord) - TransTexCoord ) ) {
                comp = LocalShadow_GetSelfShadowRate(TransTexCoord, IN.ZCalcTex2.z);
            }
            comp = min(saturate(LightNormal / max(M0032_SELFSHADOW_BIAS, 0.01f)), comp);

            // eFɔZx
            LocalShadow_COLOR ls_Out = LocalShadow_GetShadowDensity(Color, ShadowColor, use_toon, LightNormal);
            Color = ls_Out.Color;
            ShadowColor = ls_Out.ShadowColor;

        }else
        #endif

        // HgShadowɂՕ
        #if (M0032_SELFSHADOWMODE == 3)
        if( HgShadow_Valid ){

            // e攻
            comp = HgShadow_GetSelfShadowRate(IN.PPos);
            comp = min(saturate(LightNormal / max(M0032_SELFSHADOW_BIAS, 0.01f)), comp);

            // eFɔZx
            HgShadow_COLOR hgs_Color = HgShadow_GetShadowDensity(Color, ShadowColor, use_toon, LightNormal);
            Color = hgs_Color.Color;
            ShadowColor = hgs_Color.ShadowColor;

        }else
        #endif

        // ExcellentShadowɂՕ
        #if (M0032_SELFSHADOWMODE == 4)
        if( Exist_ExcellentShadow ){

            // e攻
            ExShadow_RATE es_Rate = ExShadow_GetSelfShadowRate(IN.PPos);
            es_Rate.SadowMapVal = min(saturate(LightNormal / max(M0032_SELFSHADOW_BIAS, 0.01f)), es_Rate.SadowMapVal);

            // FEeF߂
            ExShadow_COLOR es_Color = ExShadow_GetSelfShadowColor(es_Rate, Color, ShadowColor, use_toon);
            comp = es_Rate.SadowMapVal;
            Color = es_Color.Color;
            ShadowColor = es_Color.ShadowColor;

        }else
        #endif

        // MMDWVhE}bvɂՕ
        {
            // eNX`Wɕϊ
            IN.ZCalcTex /= IN.ZCalcTex.w;
            float2 TransTexCoord;
            TransTexCoord.x = (1.0f + IN.ZCalcTex.x)*0.5f;
            TransTexCoord.y = (1.0f - IN.ZCalcTex.y)*0.5f;

            if( !any( saturate(TransTexCoord) - TransTexCoord ) ) {
                #if (M0032_SELFSHADOWMODE == 2)
                    comp = HgToonShader_GetMMDSelfShadowRate(IN.ZCalcTex.z, TransTexCoord, MMDShadowMapSampler, true, M0032_SOTSHADOWMODE_BLUR);
                #else
                    comp = HgToonShader_GetMMDSelfShadowRate(IN.ZCalcTex.z, TransTexCoord, MMDShadowMapSampler, false, 1.0f);
                #endif
                comp = min(saturate(LightNormal / max(M0032_SELFSHADOW_BIAS, 0.01f)), comp);
            }
        }

        // e̍
        comp = tex2D( M0032_ToonMapSelfShadowSamp, float2(comp, 0.5f) ).x;
        Color = lerp(ShadowColor, Color, comp);
    }
    #endif

    if(UseSelfShadow){
        // 
        if( use_toon ){
           if( transp ) Color.a *= 0.5f;
        }else{
           Color.a *= AcsTrans;
        }
    }

    // K}␳
    #ifdef M0032_USE_CHANGE_GAMMA
        Color.rgb = pow(Color.rgb, M0032_GAMMA_PARAM);
    #endif

    // RgXg␳
    #ifdef M0032_USE_CHANGE_CONTRAST
        Color.rgb = HgToonShader_ChangeContrast(Color.rgb, M0032_CONTRAST_POWER);
    #endif

    // tlsߗ
    #ifdef M0032_USE_FRESNELTRANS
        Color = HgToonShader_FresnelTrans(Color, Normal, ViewDir);
    #endif

    // Ɠx菜
    #ifdef M0032_COLOR_THRESHOLD
        Color.rgb = clamp(Color.rgb, 0.0f, 0.98f);
    #endif

    return Color;
}

//--------------------------------------------------------------------------
// IuWFNg`peNjbN

// ZtVhE`
technique M0032_ObjectTech1  < string MMDPass = "object_ss"; string Subset = M0032_SUBSET_NUMBER;
    #ifndef M0032_NOTING_RENDERTARGET
    string Script= 
    #endif
    #ifdef M0032_USE_COLORREMAP
        "RenderColorTarget0=M0032_ColorRemapTexture;"
            "RenderDepthStencilTarget=M0032_ColorRemapDepthBuffer;"
                "ClearSetColor=M0032_ColorRemapClearColor; Clear=Color;"
                "ClearSetDepth=M0032_ColorRemapClearDepth; Clear=Depth;"
            "Pass=CreateColorRemapTexture;"
    #endif
    #ifdef M0032_USE_INSTANTNORMALMAP
        "RenderColorTarget0=M0032_InstantNormalMapTexture;"
            "RenderDepthStencilTarget=M0032_InstantNormalMapDepthBuffer;"
                "ClearSetColor=M0032_InstantNormalMapClearColor; Clear=Color;"
                "ClearSetDepth=M0032_InstantNormalMapClearDepth; Clear=Depth;"
            "Pass=CreateInstantNormalMap;"
    #endif
    #ifndef M0032_NOTING_RENDERTARGET
        "RenderColorTarget0=;"
            "RenderDepthStencilTarget=;"
            "Pass=DrawObject;"
        ;
    #endif
>{
    #ifdef M0032_USE_COLORREMAP
    pass CreateColorRemapTexture < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        ZEnable = FALSE;
        VertexShader = compile vs_2_0 M0032_VS_ColorRemapCreater();
        PixelShader  = compile ps_2_0 M0032_PS_ColorRemapCreater();
    }
    #endif
    #ifdef M0032_USE_INSTANTNORMALMAP
    pass CreateInstantNormalMap < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        ZEnable = FALSE;
        VertexShader = compile vs_2_0 M0032_VS_InstantNormalMapCreater();
        PixelShader  = compile ps_2_0 M0032_PS_InstantNormalMapCreater();
    }
    #endif
    pass DrawObject {
        VertexShader = compile vs_3_0 M0032_VS_Object();
        PixelShader  = compile ps_3_0 M0032_PS_Object(true);
    }
}

// ZtVhE`
technique M0032_ObjectTech2  < string MMDPass = "object"; string Subset = M0032_SUBSET_NUMBER;
    #ifndef M0032_NOTING_RENDERTARGET
    string Script= 
    #endif
    #ifdef M0032_USE_COLORREMAP
        "RenderColorTarget0=M0032_ColorRemapTexture;"
            "RenderDepthStencilTarget=M0032_ColorRemapDepthBuffer;"
                "ClearSetColor=M0032_ColorRemapClearColor; Clear=Color;"
                "ClearSetDepth=M0032_ColorRemapClearDepth; Clear=Depth;"
            "Pass=CreateColorRemapTexture;"
    #endif
    #ifdef M0032_USE_INSTANTNORMALMAP
        "RenderColorTarget0=M0032_InstantNormalMapTexture;"
            "RenderDepthStencilTarget=M0032_InstantNormalMapDepthBuffer;"
                "ClearSetColor=M0032_InstantNormalMapClearColor; Clear=Color;"
                "ClearSetDepth=M0032_InstantNormalMapClearDepth; Clear=Depth;"
            "Pass=CreateInstantNormalMap;"
    #endif
    #ifndef M0032_NOTING_RENDERTARGET
        "RenderColorTarget0=;"
            "RenderDepthStencilTarget=;"
            "Pass=DrawObject;"
        ;
    #endif
>{
    #ifdef M0032_USE_COLORREMAP
    pass CreateColorRemapTexture < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        ZEnable = FALSE;
        VertexShader = compile vs_2_0 M0032_VS_ColorRemapCreater();
        PixelShader  = compile ps_2_0 M0032_PS_ColorRemapCreater();
    }
    #endif
    #ifdef M0032_USE_INSTANTNORMALMAP
    pass CreateInstantNormalMap < string Script= "Draw=Buffer;"; > {
        AlphaBlendEnable = FALSE;
        ZEnable = FALSE;
        VertexShader = compile vs_2_0 M0032_VS_InstantNormalMapCreater();
        PixelShader  = compile ps_2_0 M0032_PS_InstantNormalMapCreater();
    }
    #endif
    pass DrawObject {
        VertexShader = compile vs_3_0 M0032_VS_Object();
        PixelShader  = compile ps_3_0 M0032_PS_Object(false);
    }
}


////////////////////////////////////////////////////////////////////////////////////////////////
// ֊s`
#ifdef M0032_DRAW_EDGE

float4 M0032_VS_Edge(float4 Pos : POSITION) : POSITION 
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 M0032_PS_Edge() : COLOR
{
    // ֊sFœhԂ
    #ifndef M0032_USE_CHANGE_EDGECOLOR
    return EdgeColor;
    #else
    return float4(M0032_CHANGE_EDGECOLOR, 1.0f);
    #endif
}

// ֊s`peNjbN
technique M0032_EdgeTech < string MMDPass = "edge"; string Subset = M0032_SUBSET_NUMBER; > {

    pass DrawEdge {
        VertexShader = compile vs_2_0 M0032_VS_Edge();
        PixelShader  = compile ps_2_0 M0032_PS_Edge();
    }

}

#else

technique M0032_EdgeTech < string MMDPass = "edge"; string Subset = M0032_SUBSET_NUMBER; > { }

#endif

/*
///////////////////////////////////////////////////////////////////////////////////////////////
// eiZtVhEj`

// _VF[_
float4 VS_Shadow(float4 Pos : POSITION) : POSITION
{
    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 PS_Shadow() : COLOR
{
    // nʉeFœhԂ
    return GroundShadowColor;
}

// e`peNjbN
technique ShadowTech < string MMDPass = "shadow"; string Subset = SUBSET_NUM; > {
    pass DrawShadow {
        VertexShader = compile vs_2_0 VS_Shadow();
        PixelShader  = compile ps_2_0 PS_Shadow();
    }
}


///////////////////////////////////////////////////////////////////////////////////////////////
// ZtVhEpZlvbg

struct VS_ZPlotOUTPUT {
    float4 Pos          : POSITION;   // ˉeϊW
    float4 ShadowMapTex : TEXCOORD0;  // Zobt@eNX`
};

// _VF[_
VS_ZPlotOUTPUT VS_ZPlot( float4 Pos : POSITION )
{
    VS_ZPlotOUTPUT Out = (VS_ZPlotOUTPUT)0;

    // Cg̖ڐɂ郏[hr[ˉeϊ
    Out.Pos = mul( Pos, LightWorldViewProjMatrix );

    // eNX`W𒸓_ɍ킹
    Out.ShadowMapTex = Out.Pos;

    return Out;
}

// sNZVF[_
float4 PS_ZPlot( VS_ZPlotOUTPUT IN ) : COLOR
{
    // RFZlL^
    return float4(IN.ShadowMapTex.z/IN.ShadowMapTex.w, 0, 0, 1);
}

// ZlvbgpeNjbN
technique ZplotTech < string MMDPass = "zplot"; string Subset = SUBSET_NUM; > {
    pass ZValuePlot {
        AlphaBlendEnable = FALSE;
        VertexShader = compile vs_2_0 VS_ZPlot();
        PixelShader  = compile ps_2_0 PS_ZPlot();
    }
}
*/

///////////////////////////////////////////////////////////////////////////////////////////////
#else

#ifndef MIKUMIKUSHADING_TEST
    #include "MMShader/HgToonShader/M0032_HgToonShader_Mirror.fxh"
#else
    #include "HgToonShader_Mirror.fxh"
#endif

#endif
