#ifndef LocalShadow_OBJHEADER
#define LocalShadow_OBJHEADER
////////////////////////////////////////////////////////////////////////////////////////////////
//
//  LocalShadow_Header.fxh : LocalShadow VhE}bv쐬ɕKvȊ{p[^`wb_t@C
//  ̃p[^𑼂̃GtFNgt@C #include Ďgp܂B
//  쐬: jP
//  MikuMikuShadingΉ̊eGtFNg͋ɗ͂̃t@CincludeĎgp邱Ƃ𐄏܂
//
////////////////////////////////////////////////////////////////////////////////////////////////
// ̃p[^ύXĂ
// t@CXVɢMMEffectSčXVŎQƂĂGtFNgt@CXVKv܂

// VhE}bvobt@TCY
#define LocalShadow_ShadowMapSize  512

// VSMVhE}bv̎
#define LocalShadow_UseSoftShadow  1
// 0 : Ȃ(\tgVhE͎gȂǕ`摬x͌シ)
// 1 : (\tgVhEg悤ɂȂ܂)


// Ȃl͂牺͂Ȃł

////////////////////////////////////////////////////////////////////////////////////////////////
// p[^錾

#ifndef LOCALSHADOW_MAIN

// Rg[p[^
#define LSM_FLIENAME   "LocalShadow.pmx"
bool LocalShadow_Valid          : CONTROLOBJECT < string name = LSM_FLIENAME; >;
float4x4 LocalShadow_BoneMatrix : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "Z^["; >;
float LocalShadow_MorphSize1    : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "͈͏k"; >;
float LocalShadow_MorphSize2    : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "͈͊g"; >;
float LocalShadow_MorphSize2X   : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "X͈͊g"; >;
float LocalShadow_MorphSize2Y   : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "Y͈͊g"; >;
float LocalShadow_MorphDist1    : CONTROLOBJECT < string name = LSM_FLIENAME; string item = ""; >;
float LocalShadow_MorphDist2    : CONTROLOBJECT < string name = LSM_FLIENAME; string item = ""; >;
float LocalShadow_MorphLtSync1  : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "LtAeA"; >;
float LocalShadow_MorphLtSync2  : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "LtՉeA"; >;
float LocalShadow_MorphLtCtrl   : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "LteZ"; >;
float LocalShadow_ObjTr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;

// Cg(Rg[ݒ)
float3 LocalShadow_LtDirection : DIRECTION < string Object = "Light"; >;
static float3 LocalShadow_LtCtrlDir = normalize(LocalShadow_BoneMatrix._31_32_33);
static float3 LocalShadow_LightDirection = normalize(lerp(LocalShadow_LtCtrlDir, LocalShadow_LtDirection, LocalShadow_MorphLtSync2));

// Cg
static float LocalShadow_Distance = 15.0f - 14.0f*LocalShadow_MorphDist1 + 85.0f*LocalShadow_MorphDist2;


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Wϊs

// Cg̃r[ϊs
float4x4 LocalShadow_LightViewMatrix()
{
   // zxNg
   float3 viewZ = LocalShadow_LightDirection;

   // xxNg
   float3 viewX = cross( LocalShadow_BoneMatrix._21_22_23, LocalShadow_LightDirection ); 

   // xxNg̐K(LookDirLookUpDir̕vꍇْ͓lƂȂ)
   if( !any(viewX) ) viewX = LocalShadow_BoneMatrix._11_21_31;
   viewX = normalize(viewX);

   // yxNg
   float3 viewY = cross( viewZ, viewX );  // ɐȂ̂łŐK

   // r[Wϊ̉]s
   float3x3 ltViewRot = float3x3( viewX.x, viewY.x, viewZ.x,
                                  viewX.y, viewY.y, viewZ.y,
                                  viewX.z, viewY.z, viewZ.z );

   // ̌ʒu
   float3 ltViewPos = LocalShadow_BoneMatrix._41_42_43 - LocalShadow_LightDirection * LocalShadow_Distance;

   // r[ϊs
   return float4x4( ltViewRot[0],  0,
                    ltViewRot[1],  0,
                    ltViewRot[2],  0,
                   -mul( ltViewPos, ltViewRot ), 1 );
}


// Cg̎ˉeϊs
float4x4 LocalShadow_LightProjMatrix()
{
   float sx = 1.0f / (5.0f - 4.0f*LocalShadow_MorphSize1 + 20.0f*LocalShadow_MorphSize2 + 95.0f*LocalShadow_MorphSize2X);
   float sy = 1.0f / (5.0f - 4.0f*LocalShadow_MorphSize1 + 20.0f*LocalShadow_MorphSize2 + 95.0f*LocalShadow_MorphSize2Y);
   float d = 0.5f / LocalShadow_Distance;

   return float4x4( sx, 0,  0, 0,
                    0,  sy, 0, 0,
                    0,  0,  d, 0,
                    0,  0,  0, 1 );
}


float4x4 LocalShadow_WorldMatrix : WORLD;

static float4x4 LocalShadow_LightViewProjMatrix = mul( LocalShadow_LightViewMatrix(), LocalShadow_LightProjMatrix() );
static float4x4 LocalShadow_LightWorldViewProjMatrix = mul( LocalShadow_WorldMatrix, LocalShadow_LightViewProjMatrix );

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Cg̏C

float3 LocalShadow_GetLightDirection(float3 ltDir)
{
    if( LocalShadow_Valid ){
        ltDir = normalize( lerp(LocalShadow_LtCtrlDir, ltDir, LocalShadow_MorphLtSync1) );
    }
    return ltDir;
}


////////////////////////////////////////////////////////////////////////////////////////////////
// VSMVhE}bv֘Ȁ

#ifndef LOCALSHADOWMAPDRAW

// ڂx
float LocalShadow_MorphSdBulr : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "eڂ"; >;
static float LocalShadow_ShadowBulrPower = LocalShadow_MorphSdBulr * 5.0f;

// eZx
float LocalShadow_MorphSdDens1 : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "e";   >;
float LocalShadow_MorphSdDens2 : CONTROLOBJECT < string name = LSM_FLIENAME; string item = "eZ";   >;
static float LocalShadow_LtCtrlDens = smoothstep(-1.5f+1.5f*LocalShadow_MorphLtCtrl, LocalShadow_MorphLtCtrl, dot(LocalShadow_LtCtrlDir, LocalShadow_LtDirection));
static float LocalShadow_Density1 = (1.0f - LocalShadow_MorphSdDens1) * LocalShadow_LtCtrlDens;
static float LocalShadow_Density2 = 1.0f + 5.0f * LocalShadow_MorphSdDens2;

// LocalShadowɂVhE}bvobt@
shared texture2D LocalShadow_SMapBuff : RENDERCOLORTARGET;
sampler LocalShadow_ShadowMapSamp = sampler_state {
    texture = <LocalShadow_SMapBuff>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
    AddressU  = CLAMP;
    AddressV = CLAMP;
};

#if LocalShadow_UseSoftShadow==1

    // VhE}bv̎ӃTvO
    #define LocalShadow_BASESMAP_COUNT  4

    // VhE}bvobt@TCY
    #define LocalShadow_SMAPSIZE_WIDTH   LocalShadow_ShadowMapSize
    #define LocalShadow_SMAPSIZE_HEIGHT  LocalShadow_ShadowMapSize

    // VhE}bṽTvOԊu
    static float2 LocalShadow_SMapSampStep = float2(LocalShadow_ShadowBulrPower/LocalShadow_SMAPSIZE_WIDTH,
                                                    LocalShadow_ShadowBulrPower/LocalShadow_SMAPSIZE_HEIGHT);

    // VhE}bv̎ӃTvO1
    float2 LocalShadow_GetZPlotSampleBase1(float2 Tex, float smpScale)
    {
        float2 smpStep = LocalShadow_SMapSampStep * smpScale;
        float mipLv = log2( max(LocalShadow_SMAPSIZE_WIDTH*smpStep.x, 1.0f) );
        float2 zplot = tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex, 0, mipLv)).xy * 2.0f;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2(-1,-1), 0, mipLv)).xy;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2( 1,-1), 0, mipLv)).xy;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2(-1, 1), 0, mipLv)).xy;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2( 1, 1), 0, mipLv)).xy;
        return (zplot / 6.0f);
    }

    // VhE}bv̎ӃTvO2
    float2 LocalShadow_GetZPlotSampleBase2(float2 Tex, float smpScale)
    {
        float2 smpStep = LocalShadow_SMapSampStep * smpScale;
        float mipLv = log2( max(LocalShadow_SMAPSIZE_WIDTH*smpStep.x, 1.0f) );
        float2 zplot = tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex, 0, mipLv)).xy * 2.0f;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2(-1, 0), 0, mipLv)).xy;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2( 1, 0), 0, mipLv)).xy;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2( 0,-1), 0, mipLv)).xy;
        zplot += tex2Dlod(LocalShadow_ShadowMapSamp, float4(Tex+smpStep*float2( 0, 1), 0, mipLv)).xy;
        return (zplot / 6.0f);
    }

    // ZtVhE̎Օm߂
    float LocalShadow_GetSelfShadowRate(float2 SMapTex, float z)
    {
        // VhE}bvZvbg̓v(zplot.x:, zplot.y:2敽)
        float2 zplot = float2(0,0);
        float rate = 1.0f;
        float sumRate = 0.0f;
        [unroll]
        for(int i=0; i<LocalShadow_BASESMAP_COUNT; i+=2) {
            rate *= 0.5f; sumRate += rate;
            zplot += LocalShadow_GetZPlotSampleBase1(SMapTex, float(i+1)) * rate;
            rate *= 0.5f; sumRate += rate;
            zplot += LocalShadow_GetZPlotSampleBase2(SMapTex, float(i+2)) * rate;
        }
        zplot /= sumRate;

        // e(VSM:Variance Shadow Maps@)
        float variance = max( zplot.y - zplot.x * zplot.x, 0.05f/LocalShadow_Distance );
        float comp = variance / (variance + max(z - zplot.x, 0.0f));

        comp = smoothstep(0.1f/max(LocalShadow_ShadowBulrPower, 1.0f), 1.0f, comp);
        return (1.0f-(1.0f-comp)*LocalShadow_Density1);
    }

#else

    #define LocalShadow_SKII1  (200.0f*LocalShadow_Distance)

    // ZtVhE̎Օm߂(\tgVhEgȂꍇ)
    float LocalShadow_GetSelfShadowRate(float2 SMapTex, float z)
    {
        float comp;
        float dist = max( z - tex2D(LocalShadow_ShadowMapSamp, SMapTex).r, 0.0f );
        comp = 1.0f - saturate( dist * LocalShadow_SKII1 - 7.0f);

        return (1.0f-(1.0f-comp)*LocalShadow_Density1);
    }

#endif


////////////////////////////////////////////////////////////////////////////////////////////////
// Zxݒ֘Ȁ

struct  LocalShadow_COLOR {
    float4 Color;        // IuWFNgF
    float4 ShadowColor;  // eF
};

// eFɔZx
LocalShadow_COLOR LocalShadow_GetShadowDensity(float4 Color, float4 ShadowColor, bool useToon, float LightNormal)
{
    LocalShadow_COLOR Out;
    Out.Color = Color;
    Out.ShadowColor = ShadowColor;

    if( !useToon || length(Color.rgb-ShadowColor.rgb) > 0.01f ){
        float e = max(LocalShadow_Density2, 1.0f);
        float a = 1.0f / e;
        float b = 1.0f - smoothstep(3.0f, 6.0f, e);
        float3 color = lerp(ShadowColor.rgb*a, ShadowColor.rgb*b, pow(ShadowColor.rgb, e));
        Out.ShadowColor = float4(saturate(color), ShadowColor.a);
    }
    if( !useToon ){
        float e = lerp( LocalShadow_Density2, 1.0f, smoothstep(0.0f, 0.4f, LightNormal) );
        float a = 1.0f / e;
        float b = 1.0f - smoothstep(4.0f, 5.0f, e);
        float3 color = lerp(Color.rgb*a, Color.rgb*b, pow(Color.rgb, e));
        Out.Color = float4(saturate(color), Color.a);
        Out.Color.a *= LocalShadow_ObjTr;
        Out.ShadowColor.a *= LocalShadow_ObjTr;
    }

    return Out;
}


#endif
#endif

////////////////////////////////////////////////////////////////////////////////////////////////
#endif
