////////////////////////////////////////////////////////////////////////////////////////////////
//
//  MMD_Parameters.fxh : MMD瓾鋤ʂ̃p[^
//  MikuMikuShadingΉ̊eGtFNg͋ɗ͂̃t@CincludeĎgp邱Ƃ𐄏܂
//
////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef MikuMikuShading_MMD_PARAMETERS
#define MikuMikuShading_MMD_PARAMETERS

// Wϊs
float4x4 WorldMatrix              : WORLD;
float4x4 ViewMatrix               : VIEW;
float4x4 ProjMatrix               : PROJECTION;
float4x4 WorldViewMatrix          : WORLDVIEW;
float4x4 ViewProjMatrix           : VIEWPROJECTION;
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 LightViewProjMatrix      : VIEWPROJECTION < string Object = "Light"; >;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;

// CgEJ
float3 LightDirection  : DIRECTION < string Object = "Light"; >;
float3 CameraDirection : DIRECTION < string Object = "Camera"; >;
float3 CameraPosition  : POSITION  < string Object = "Camera"; >;

// }eAF
float4 MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3 MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3 MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float3 MaterialSpecular  : SPECULAR < string Object = "Geometry"; >;
float  SpecularPower     : SPECULARPOWER < string Object = "Geometry"; >;
float3 MaterialToon      : TOONCOLOR;
float4 EdgeColor         : EDGECOLOR;
float4 GroundShadowColor : GROUNDSHADOWCOLOR;
// CgF
float3 LightDiffuse   : DIFFUSE   < string Object = "Light"; >;
float3 LightAmbient   : AMBIENT   < string Object = "Light"; >;
float3 LightSpecular  : SPECULAR  < string Object = "Light"; >;

// ANZTTrl(ANZeOn̎MaterialDiffuse.aŃlȂ̂łŒ`)
float AcsTrans : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;

// eNX`ގ[tl
float4 TextureAddValue  : ADDINGTEXTURE;
float4 TextureMulValue  : MULTIPLYINGTEXTURE;
float4 SphereAddValue   : ADDINGSPHERETEXTURE;
float4 SphereMulValue   : MULTIPLYINGSPHERETEXTURE;

bool use_texture;     // eNX`gptO
bool use_spheremap;   // XtBA}bvgptO
bool use_toon;        // gD[_OgptO
bool use_subtexture;  // TueNX`tO

bool parthf;   // ZtVhEmode1/mode2tO
bool spadd;    // XtBA}bvZtO
bool transp;   // tO
bool opadd;    // ZtO

int VertexCount;   // IuWFNg̒_
int SubsetCount;   // IuWFNg̍ގ

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
    texture = <ObjectTexture>;
    MINFILTER = ANISOTROPIC;
    MAGFILTER = ANISOTROPIC;
    MIPFILTER = LINEAR;
    MAXANISOTROPY = 16;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

// gD[}bṽeNX`
texture ObjectToonTexture: MATERIALTOONTEXTURE;
sampler ObjToonSampler = sampler_state {
    texture = <ObjectToonTexture>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = NONE;
    ADDRESSU  = CLAMP;
    ADDRESSV  = CLAMP;
};

// VhEobt@̃TvB"register(s0)"Ȃ̂MMDs0gĂ邩
sampler MMDShadowMapSampler : register(s0);


#endif

